# This file was created automatically by SWIG.
import stressfreestrainc
from oof2.SWIG.engine.properties import PropertyPtr
from oof2.SWIG.engine.symmmatrix import SymmMatrix3Ptr
class IsotropicStressFreeStrainPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C IsotropicStressFreeStrain instance at %s>" % (self.this,)
class IsotropicStressFreeStrain(IsotropicStressFreeStrainPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(stressfreestrainc.new_IsotropicStressFreeStrain,_args,_kwargs)
        self.thisown = 1




class AnisotropicStressFreeStrainPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C AnisotropicStressFreeStrain instance at %s>" % (self.this,)
class AnisotropicStressFreeStrain(AnisotropicStressFreeStrainPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(stressfreestrainc.new_AnisotropicStressFreeStrain,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: stressfreestrain.spy,v $
# $Revision: 1.2 $
# $Author: langer $
# $Date: 2006-07-12 15:04:19 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 


from oof2.SWIG.engine import symmmatrix
from oof2.common import utils
from oof2.common.IO import parameter
from oof2.engine import problem
from oof2.engine import propertyregistration

PropertyRegistration = propertyregistration.PropertyRegistration

PropertyRegistration(
    'Mechanical:StressFreeStrain:Isotropic',
    IsotropicStressFreeStrain,
    "oof2.SWIG.engine.property.stressfreestrain.stressfreestrain",
    22,
    [parameter.FloatParameter('epsilon0', 0.0, tip="StressFreeStrain")],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="StressFreeStrain",
    tip="Isotropic stress-free strain")


PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Cubic',
    AnisotropicStressFreeStrain,
    "oof2.SWIG.engine.property.stressfreestrain.stressfreestrain",
    23,
    [symmmatrix.CubicRank2TensorParameter('epsilon0',
                                          symmmatrix.CubicRank2Tensor(xx=1.0),
                                          tip='Stress-free strain tensor')],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="StressFreeStrain",
    tip="Cubic stress-free strain")
    
PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Hexagonal',
    AnisotropicStressFreeStrain,
    "oof2.SWIG.engine.property.stressfreestrain.stressfreestrain",
    24,
    [symmmatrix.HexagonalRank2TensorParameter(
    'epsilon0',
    symmmatrix.HexagonalRank2Tensor(xx=1.0, zz=0.5),
    tip='Stress-free strain tensor')],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="StressFreeStrain",
    tip="Hexagonal stress-free strain")
    
PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Trigonal',
    AnisotropicStressFreeStrain,
    "oof2.SWIG.engine.property.stressfreestrain.stressfreestrain",
    25,
    [symmmatrix.TrigonalRank2TensorParameter(
    'epsilon0',
    symmmatrix.TrigonalRank2Tensor(xx=1.0, zz=0.5),
    tip='Stress-free strain tensor')],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="StressFreeStrain",
    tip="Trigonal stress-free strain")
    
PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Tetragonal',
    AnisotropicStressFreeStrain,
    "oof2.SWIG.engine.property.stressfreestrain.stressfreestrain",
    26,
    [symmmatrix.TetragonalRank2TensorParameter(
    'epsilon0',
    symmmatrix.TetragonalRank2Tensor(xx=1.0, zz=0.5),
    tip='Stress-free strain tensor')],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="StressFreeStrain",
    tip="Tetragonal stress-free strain")
    
PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Orthorhombic',
    AnisotropicStressFreeStrain,
    "oof2.SWIG.engine.property.stressfreestrain.stressfreestrain",
    27,
    [symmmatrix.OrthorhombicRank2TensorParameter(
    'epsilon0',
    symmmatrix.OrthorhombicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
    tip='Stress-free strain tensor')],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="StressFreeStrain",
    tip="Orthorhombic stress-free strain")
    
PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Monoclinic',
    AnisotropicStressFreeStrain,
    "oof2.SWIG.engine.property.stressfreestrain.stressfreestrain",
    26,
    [symmmatrix.MonoclinicRank2TensorParameter(
    'epsilon0',
    symmmatrix.MonoclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
    tip='Stress-free strain tensor')],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="StressFreeStrain",
    tip="Monoclinic stress-free strain")
    
PropertyRegistration(
    'Mechanical:StressFreeStrain:Anisotropic:Triclinic',
    AnisotropicStressFreeStrain,
    "oof2.SWIG.engine.property.stressfreestrain.stressfreestrain",
    26,
    [symmmatrix.TriclinicRank2TensorParameter(
    'epsilon0',
    symmmatrix.TriclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
    tip='Stress-free strain tensor')],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="StressFreeStrain",
    tip="Triclinic stress-free strain")
    
