# This file was created automatically by SWIG.
import solverc
class LinearSolverPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def status(self, *_args, **_kwargs):
        val = apply(solverc.LinearSolver_status,(self,) + _args, _kwargs)
        return val
    def message(self, *_args, **_kwargs):
        val = apply(solverc.LinearSolver_message,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C LinearSolver instance at %s>" % (self.this,)
class LinearSolver(LinearSolverPtr):
    def __init__(self,this):
        self.this = this




class GMRESSolverPtr(LinearSolverPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,solverc=solverc):
        if self.thisown == 1 :
            solverc.delete_GMRESSolver(self)
    def __repr__(self):
        return "<C GMRESSolver instance at %s>" % (self.this,)
class GMRESSolver(GMRESSolverPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(solverc.new_GMRESSolver,_args,_kwargs)
        self.thisown = 1




class BiCGSolverPtr(LinearSolverPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,solverc=solverc):
        if self.thisown == 1 :
            solverc.delete_BiCGSolver(self)
    def __repr__(self):
        return "<C BiCGSolver instance at %s>" % (self.this,)
class BiCGSolver(BiCGSolverPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(solverc.new_BiCGSolver,_args,_kwargs)
        self.thisown = 1




class CGSolverPtr(LinearSolverPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,solverc=solverc):
        if self.thisown == 1 :
            solverc.delete_CGSolver(self)
    def __repr__(self):
        return "<C CGSolver instance at %s>" % (self.this,)
class CGSolver(CGSolverPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(solverc.new_CGSolver,_args,_kwargs)
        self.thisown = 1




class BiCGStabSolverPtr(LinearSolverPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,solverc=solverc):
        if self.thisown == 1 :
            solverc.delete_BiCGStabSolver(self)
    def __repr__(self):
        return "<C BiCGStabSolver instance at %s>" % (self.this,)
class BiCGStabSolver(BiCGStabSolverPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(solverc.new_BiCGStabSolver,_args,_kwargs)
        self.thisown = 1




class DirectSolverPtr(LinearSolverPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,solverc=solverc):
        if self.thisown == 1 :
            solverc.delete_DirectSolver(self)
    def __repr__(self):
        return "<C DirectSolver instance at %s>" % (self.this,)
class DirectSolver(DirectSolverPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(solverc.new_DirectSolver,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: solver.spy,v $
# $Revision: 1.4 $
# $Author: langer $
# $Date: 2007-01-08 18:27:31 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from oof2.common import cregisteredclass
from oof2.common import debug
from oof2.common.IO import parameter
from oof2.common.IO import xmlmenudump
from oof2.SWIG.engine.preconditioner import PreconditionerPtr



def _apply(self, meshcontext):
    from oof2.SWIG.engine import solverdriver
    equilibrate = solverdriver.SolverDriver(
        self, meshcontext, solverdriver.SolverIterationManager(1))
    equilibrate.precompute()
    equilibrate.iterate()
    equilibrate.short_postcompute()

LinearSolverPtr.apply = _apply



cregisteredclass.registerCClass(LinearSolverPtr)

LinearSolverPtr.tip = "Solution methods for linear matrix equations."
LinearSolverPtr.discussion = \
              xmlmenudump.loadFile('DISCUSSIONS/engine/reg/linear_solver.xml')


class LinearSolverRegistration(cregisteredclass.Registration):
    def __init__(self, name, regclass, subclass, ordering, params=[],
                 secret=0, symmetric=None, **kwargs):
        self.symmetric = symmetric
        cregisteredclass.Registration.__init__(self, name, regclass,
                                               subclass, ordering,
                                               params=params,
                                               secret=secret, **kwargs)

# Special class so linear solver parameters can have a special
# makeWidget -- see solverPage.py.
class LinearSolverParameter(parameter.RegisteredParameter):
    def __init__(self, name, value=None, default=None, tip=None):
        parameter.RegisteredParameter.__init__(
            self, name, LinearSolverPtr,
            value=value, default=default, tip=tip)

# This one is assigned to a variable because the skeleton relaxation
# method needs to refer to it.
gmresSolver = LinearSolverRegistration(
    "GMRES",
    LinearSolverPtr,
    GMRESSolver,
    ordering=200,
    params=[
    parameter.IntParameter("max_iterations", 1000,
                           tip="maximum number of iterations to perform"),
    parameter.IntParameter("krylov_dimension", 100,
                           tip="Making the Krylov dimension bigger will improve convergence but use more memory."),
    parameter.FloatParameter("tolerance", 1.e-13,
                             tip="largest acceptable relative error"),
    parameter.RegisteredParameter("preconditioner",
                                  PreconditionerPtr,
                                  tip="Black magic for making the matrix more easily solvable")
    ],
    tip="Generalized Minimal Residual method.  An iterative method for non-symmetric matrices.",
    discussion=xmlmenudump.loadFile('DISCUSSIONS/engine/reg/gmres.xml')
    )

LinearSolverRegistration(
    "BiCG",
    LinearSolverPtr,
    BiCGSolver,
    ordering=300,
    params=[
    parameter.IntParameter("max_iterations", 1000,
                           tip="maximum number of iterations to perform"),
    parameter.FloatParameter("tolerance", 1.e-13,
                             tip="largest acceptable relative error"),
    parameter.RegisteredParameter("preconditioner",
                                  PreconditionerPtr,
                                  tip="Black magic for making the matrix more easily solvable")
    ],
    tip="Bi-Conjugate Gradient method.  An iterative method for non-symmetric matrices.",
    discussion=xmlmenudump.loadFile('DISCUSSIONS/engine/reg/bicg.xml')
    )

cgSolver = LinearSolverRegistration(
    "CG",
    LinearSolverPtr,
    CGSolver,
    ordering=100,
    params=[
    parameter.IntParameter("max_iterations",  1000,
                           tip="maximum number of iterations to perform"),
    parameter.FloatParameter("tolerance", 1.e-13,
                             tip="largest acceptable relative error"),
    parameter.RegisteredParameter("preconditioner",
                                  PreconditionerPtr,
                                  tip="Black magic for making the matrix more easily solvable")
    ],
    symmetric=1,
    tip="Conjugate Gradient method for solving symmetric matrices.",
    discussion=xmlmenudump.loadFile('DISCUSSIONS/engine/reg/cg.xml')
    )

LinearSolverRegistration(
    "BiCGStab",
    LinearSolverPtr,
    BiCGStabSolver,
    ordering=400,
    params=[
    parameter.IntParameter("max_iterations",  1000,
                           tip="maximum number of iterations to perform"),
    parameter.FloatParameter("tolerance", 1.e-13,
                             tip="largest acceptable relative error"),
    parameter.RegisteredParameter("preconditioner",
                                  PreconditionerPtr,
                                  tip="Black magic for making the matrix more easily solvable")
    ],
    tip="Stabilized Bi-Conjugate Gradient method for non-symmetric matrices.",
    discussion=xmlmenudump.loadFile('DISCUSSIONS/engine/reg/bicgstab.xml')
    )

LinearSolverRegistration(
    "Direct",
    LinearSolverPtr,
    DirectSolver,
    ordering=1000,
    params=[],
    tip="A non-iterative non-sparse matrix solver using LU decomposition.  Uses a lot of memory. Not recommended if the finite element mesh is large.",
    discussion=xmlmenudump.loadFile('DISCUSSIONS/engine/reg/direct.xml')
    )






