# -*- python -*-
# $RCSfile: selectionplaceholder.py,v $
# $Revision: 1.5 $
# $Author: langer $
# $Date: 2005-05-13 18:43:49 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from oof2.common import utils
from oof2.common.IO import xmlmenudump

# Special types for representing the selection in aggregate parameters
# (ie parameters that can be set to a group or the currently selected
# objects).

_allPlaceHolders = []

class PlaceHolder:
    def __init__(self):
        self.idno = len(_allPlaceHolders) + 1
        _allPlaceHolders.append(self)

class SelectionPlaceHolder(PlaceHolder):
    def __cmp__(self, other):
        if isinstance(other,SelectionPlaceHolder):
            return 0
        return 1
    def __repr__(self):
        return 'selection'

selectionPlaceHolder = SelectionPlaceHolder()
selectionIDstring = "<selection>"
utils.OOFdefine('selection', selectionPlaceHolder)

class AllPlaceHolder(PlaceHolder):
    def __cmp__(self, other):
        if isinstance(other, AllPlaceHolder):
            return 0
        return 1
    def __repr__(self):
        return 'all'

def getPlaceHolderFromID(idno):         # used in binaryRepr for AggregateParams
    if idno > 0:
        return _allPlaceHolders[idno - 1]
    
allPlaceHolder = AllPlaceHolder()
allIDstring = "<all>"
utils.OOFdefine('all', allPlaceHolder)

xmlmenudump.XMLObjectDoc(
    'Placeholder',
    xmlmenudump.loadFile("DISCUSSIONS/common/object/placeholder.xml"))
