// -*- C++ -*-
// $RCSfile: freedom.C,v $
// $Revision: 1.10 $
// $Author: langer $
// $Date: 2006-01-23 16:15:42 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>
#include "freedom.h"
#include "common/tostring.h"
#include <string>

DegreeOfFreedom::DegreeOfFreedom(double x, int ind)
  : value_(x),
    index_(ind),
    flags(0),
    nfix(0)
{}

//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//=\\=//

std::ostream &operator<<(std::ostream &os, const DegreeOfFreedom &dof) {
  os << "[" << dof.dofindex();
  if(!dof.isfree())
    os << " fixed, ";
  else
    os << " free, ";
  if(!dof.active())
    os << "inactive";
  else
    os << "active";
  os << "]";
  return os;
}
