// -*- C++ -*-
// $RCSfile: twomatrix.C,v $
// $Revision: 1.2 $
// $Author: reida $
// $Date: 2003-04-02 14:52:39 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>

#include "engine/twomatrix.h"
#include <math.h>

TwoMatrix TwoMatrix::inverse() const {
  double invdet = 1./(xx*yy - xy*yx);
  return TwoMatrix(yy*invdet, -xy*invdet, -yx*invdet, xx*invdet);
}

double TwoMatrix::norm2() const {
  return xx*xx + xy*xy + yx*yx + yy*yy;
}

double TwoMatrix::conditionNumber() const {
  return sqrt(inverse().norm2() * norm2());
}

