/* -*- C++ -*-
 $RCSfile: classify.C,v $
 $Revision: 1.7 $
 $Author: olgak $
 $Date: 2007-07-20 15:37:18 $

 This software was produced by NIST, an agency of the U.S. government,
 and by statute is not subject to copyright in the United States.
 Recipients of this software assume all responsibilities associated
 with its operation, modification and maintenance. However, to
 facilitate maintenance we ask that before distributing modified
 versions of this software, you first contact the authors at
 oof_manager@ctcms.nist.gov. */  

 #include "classify.h"
 #include "common/boolarray.h"
 #include "image/burn.h"
 #include "image/pixelselectioncourieri.h"
 using std::cout;
 
 ClassifyClass::ClassifyClass(){
	return;
 }
 
 
/*
Classifies each region by color. Assigns each region a different color so that it is easy to see where continuous regions lie. 
Doesnt quite work. Some problems. Will fix later. 
*/
DoubleArray ClassifyClass::classifyRegions(DoubleArray olchanged){
	ICoord size = olchanged.size();
	DoubleArray newchanged = DoubleArray(size);
	DoubleArray changed = DoubleArray(size);
	/* if it is not classified, 0, if classified then 1 */
	int maxSize = 7;
	int currSize0 = 0;
	int currSize1;
	int oldSize0 = 0;
	currSize0 = currSize0 + maxSize;
	double changeColor = 0;
	DoubleArray classified = DoubleArray(size);
	int reachedEnd = 0;
	for (DoubleArray::iterator i = olchanged.begin();i !=olchanged.end(); ++i){
		olchanged[i.coord()] = (int)olchanged[i.coord()];
	}
	maxSize = 1456/size(1);
	while (currSize0 <= size(0)-1){
		currSize1 = size(1);
		for (int i = oldSize0; i < currSize0; ++i){
			for (int j = 0; j < currSize1; ++j){
				ICoord curr = ICoord(i,j);
				if (classified[curr] == 0){
					cout << curr << std::endl;
					cout << olchanged[curr] << " ";
					if (pixelInBounds(curr + ICoord(-1,0), size))
						cout << olchanged[curr + ICoord(-1,0)];
					cout << std::endl;
					classified[curr] = 1;
					double currColor = olchanged[curr];
					if (pixelInBounds(curr + ICoord(-1,0), size) && classified[curr + ICoord(-1,0)] == 1  && olchanged[curr + ICoord(-1,0)] == olchanged[curr])
						changeColor = changed[curr + ICoord(-1,0)];
					else if (pixelInBounds(curr + ICoord(-1,1), size) && classified[curr + ICoord(-1,1)] == 1  && olchanged[curr + ICoord(-1,1)] == olchanged[curr])
						changeColor = changed[curr + ICoord(-1,1)];
					else if (pixelInBounds(curr + ICoord(-1,-1), size) && classified[curr + ICoord(-1,-1)] == 1 && olchanged[curr + ICoord(-1,-1)] == olchanged[curr])
						changeColor = changed[curr + ICoord(-1,-1)];
					changed[curr] = changeColor;
					changeNeighbors(curr, changed, currColor, changeColor, classified, currSize0, currSize1, olchanged);
					changeColor = changeColor + .7;
				}
			}
		}
		oldSize0 = currSize0;
		currSize0 = currSize0 + maxSize;
		if (currSize0 > size(0) -1 && reachedEnd == 0){
			currSize0 = size(0) - 1;
 			reachedEnd = 1;
		}
	}
	fixWrongBorders(changed, olchanged);
	newchanged = changed;
	return newchanged;
}

/*
When classifying regions, some pixels get missed (they are part of one region when going in parts, but are actually part of a different region. This fixes those mistakes.  Currently doesnt work yet. 
*/
void ClassifyClass::fixWrongBorders(DoubleArray & changed, DoubleArray original){
	ICoord size = changed.size();
	for (DoubleArray::iterator i = changed.begin();i !=changed.end(); ++i){
		ICoord c = i.coord();
		ICoord r = c + ICoord(-1,0);
		/*if (pixelInBounds(r) && original[c] == original[r] && changed[c] != changed[r]) {
			cout << "changing " << c << " " << r << std::endl;
			DoubleArray classified = DoubleArray(size);
			classified[c] = 1;
			classified[r] = 1;
			double before = changed[r];
			changed[r] = changed[c];
			changeNeighbors(r, changed, before, changed[c], classified, c(0), size(1), changed);
			++numChanged;
		}
		r = c + ICoord(-1,1);
		if (pixelInBounds(r) && original[c] == original[r] && changed[c] != changed[r]){
			cout << "changing " << c << " " << r << std::endl;
			DoubleArray classified = DoubleArray(size);
			classified[c] = 1;
			classified[r] = 1;
			double before = changed[r];
			changed[r] = changed[c];
			changeNeighbors(r, changed, before, changed[c], classified, c(0), size(1), changed);
		}
		r = c + ICoord(-1,-1);
		if (pixelInBounds(r) && original[c] == original[r] && changed[c] != changed[r]){
			cout << "changing " << c << " " << r << std::endl;
			DoubleArray classified = DoubleArray(size);
			classified[c] = 1;
			classified[r] = 1;
			double before = changed[r];
			changed[r] = changed[c];
			changeNeighbors(r, changed, before, changed[c], classified, c(0), size(1), changed);
		}*/
		/*r = c + ICoord(0,-1);
		if (pixelInBounds(r) && original[c] == original[r] && changed[c] != changed[r]){
			cout << "changing " << c << " " << r << std::endl;
			DoubleArray classified = DoubleArray(size);
			classified[c] = 1;
			classified[r] = 1;
			double before = changed[r];
			changed[r] = changed[c];
			changeNeighbors(r, changed, before, changed[c], classified, size(0), size(1), changed);
		}
		r = c + ICoord(1,-1);
		if (pixelInBounds(r) && original[c] == original[r] && changed[c] != changed[r]){
			cout << "changing " << c << " " << r << std::endl;
			DoubleArray classified = DoubleArray(size);
			classified[c] = 1;
			classified[r] = 1;
			double before = changed[r];
			changed[r] = changed[c];
			changeNeighbors(r, changed, before, changed[c], classified, size(0), size(1), changed);
		}
		r = c + ICoord(1,0);
		if (pixelInBounds(r) && original[c] == original[r] && changed[c] != changed[r]){
			cout << "changing " << c << " " << r << std::endl;
			DoubleArray classified = DoubleArray(size);
			classified[c] = 1;
			classified[r] = 1;
			double before = changed[r];
			changed[r] = changed[c];
			changeNeighbors(r, changed, before, changed[c], classified, size(0), size(1), changed);
		}
		r = c + ICoord(1,1);
		if (pixelInBounds(r) && original[c] == original[r] && changed[c] != changed[r]){
			cout << "changing " << c << " " << r << std::endl;
			DoubleArray classified = DoubleArray(size);
			classified[c] = 1;
			classified[r] = 1;
			double before = changed[r];
			changed[r] = changed[c];
			changeNeighbors(r, changed, before, changed[c], classified, size(0), size(1), changed);
		}
		r = c + ICoord(0,1);
		if (pixelInBounds(r) && original[c] == original[r] && changed[c] != changed[r]){
			cout << "changing " << c << " " << r << std::endl;
			DoubleArray classified = DoubleArray(size);
			classified[c] = 1;
			classified[r] = 1;
			double before = changed[r];
			changed[r] = changed[c];
			changeNeighbors(r, changed, before, changed[c], classified, size(0), size(1), changed);
		}*/
	}
}


/*
Checks if the given pixel is in bounds of the image.
*/
bool ClassifyClass::pixelInBounds(ICoord pxl, ICoord size) {
  int xx = (pxl)(0);
  int yy = (pxl)(1);
  if ( (xx<0) || (xx>=size(0)) || (yy<0) || (yy>=size(1)) )
    return false;
  return true;
}

/*
Called by classifyRegions. For the coordinate given, changes all of the pixels around it that are of its same color to a specified color. 
*/
void ClassifyClass::changeNeighbors(ICoord coord, DoubleArray &changed, double curr, double changeTo, DoubleArray &classified, int maxi, int maxj, DoubleArray old_changed){
	/* below */
	ICoord size = changed.size();
	ICoord r = coord + ICoord (0,1);
	if ((pixelInBounds(r, size) == true) && (r(0) < maxi && r(1) < maxj) && (classified[r] == 0) && (old_changed[r] == curr)) {
		if (pixelInBounds(r + ICoord(-1,0), size) && classified[r + ICoord(-1,0)] == 1  && old_changed[r + ICoord(-1,0)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,0)];
		else if (pixelInBounds(r + ICoord(-1,1), size) && classified[r + ICoord(-1,1)] == 1  && old_changed[r + ICoord(-1,1)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,1)];
		else if (pixelInBounds(r + ICoord(-1,-1), size) && classified[r + ICoord(-1,-1)] == 1 && old_changed[r + ICoord(-1,-1)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,-1)];
		classified[r] = 1;
		changed[r] = changeTo;
		if (r(0) < maxi && r(1) < maxj){
			changeNeighbors(r, changed, curr, changeTo, classified, maxi, maxj, old_changed);
		}
	}
	/* above */
	r = coord + ICoord (0,-1);
	if ((pixelInBounds(r, size) == true) && (r(0) < maxi && r(1) < maxj) && (classified[r] == 0) && (old_changed[r] == curr)) {
		if (pixelInBounds(r + ICoord(-1,0), size) && classified[r + ICoord(-1,0)] == 1  && old_changed[r + ICoord(-1,0)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,0)];
		else if (pixelInBounds(r + ICoord(-1,1), size) && classified[r + ICoord(-1,1)] == 1  && old_changed[r + ICoord(-1,1)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,1)];
		else if (pixelInBounds(r + ICoord(-1,-1), size) && classified[r + ICoord(-1,-1)] == 1 && old_changed[r + ICoord(-1,-1)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,-1)];
		classified[r] = 1;
		changed[r] = changeTo;
		if (r(0) < maxi && r(1) < maxj){
			changeNeighbors(r, changed, curr, changeTo, classified, maxi, maxj, old_changed);
		}
	}
	/*left */
	r = coord + ICoord (1,0);
	if ((pixelInBounds(r, size) == true) && (r(0) < maxi && r(1) < maxj) && (classified[r] == 0) && (old_changed[r] == curr)) {
		if (pixelInBounds(r + ICoord(-1,0), size) && classified[r + ICoord(-1,0)] == 1  && old_changed[r + ICoord(-1,0)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,0)];
		else if (pixelInBounds(r + ICoord(-1,1), size) && classified[r + ICoord(-1,1)] == 1  && old_changed[r + ICoord(-1,1)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,1)];
		else if (pixelInBounds(r + ICoord(-1,-1), size) && classified[r + ICoord(-1,-1)] == 1 && old_changed[r + ICoord(-1,-1)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,-1)];
		classified[r] = 1;
		changed[r] = changeTo;
		if (r(0) < maxi && r(1) < maxj){
			changeNeighbors(r, changed, curr, changeTo, classified, maxi, maxj, old_changed);
		}
	}
	/* right */
	r = coord + ICoord (-1,0);
	if ((pixelInBounds(r, size) == true) && (r(0) < maxi && r(1) < maxj) && (classified[r] == 0) && (old_changed[r] == curr)) {
		if (pixelInBounds(r + ICoord(-1,0), size) && classified[r + ICoord(-1,0)] == 1  && old_changed[r + ICoord(-1,0)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,0)];
		else if (pixelInBounds(r + ICoord(-1,1), size) && classified[r + ICoord(-1,1)] == 1  && old_changed[r + ICoord(-1,1)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,1)];
		else if (pixelInBounds(r + ICoord(-1,-1), size) && classified[r + ICoord(-1,-1)] == 1 && old_changed[r + ICoord(-1,-1)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,-1)];
		classified[r] = 1;
		changed[r] = changeTo;
		if (r(0) < maxi && r(1) < maxj){
			changeNeighbors(r, changed, curr, changeTo, classified, maxi, maxj, old_changed);
		}
	}
	/*r = coord + ICoord (1,-1);
	if ((image.pixelInBounds(&r) == true) && (r(0) < maxi && r(1) < maxj) && (classified[r] == 0) && (old_changed[r] == curr)) {
		if (pixelInBounds(r + ICoord(-1,0)) && classified[r + ICoord(-1,0)] == 1  && old_changed[r + ICoord(-1,0)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,0)];
		else if (pixelInBounds(r + ICoord(-1,1)) && classified[r + ICoord(-1,1)] == 1  && old_changed[r + ICoord(-1,1)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,1)];
		else if (pixelInBounds(r + ICoord(-1,-1)) && classified[r + ICoord(-1,-1)] == 1 && old_changed[r + ICoord(-1,-1)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,-1)];
		classified[r] = 1;
		changed[r] = changeTo;
		if (r(0) < maxi && r(1) < maxj){
			changeNeighbors(r, changed, curr, changeTo, classified, maxi, maxj, old_changed);
		}
	}
	
	r = coord + ICoord (-1,-1);
	if ((image.pixelInBounds(&r) == true) && (r(0) < maxi && r(1) < maxj) && (classified[r] == 0) && (old_changed[r] == curr)) {
		if (pixelInBounds(r + ICoord(-1,0)) && classified[r + ICoord(-1,0)] == 1  && old_changed[r + ICoord(-1,0)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,0)];
		else if (pixelInBounds(r + ICoord(-1,1)) && classified[r + ICoord(-1,1)] == 1  && old_changed[r + ICoord(-1,1)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,1)];
		else if (pixelInBounds(r + ICoord(-1,-1)) && classified[r + ICoord(-1,-1)] == 1 && old_changed[r + ICoord(-1,-1)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,-1)];
		classified[r] = 1;
		changed[r] = changeTo;
		if (r(0) < maxi && r(1) < maxj){
			changeNeighbors(r, changed, curr, changeTo, classified, maxi, maxj, old_changed);
		}
	}
	
	r = coord + ICoord (-1,1);
	if ((image.pixelInBounds(&r) == true) && (r(0) < maxi && r(1) < maxj) && (classified[r] == 0) && (old_changed[r] == curr)) {
		if (pixelInBounds(r + ICoord(-1,0)) && classified[r + ICoord(-1,0)] == 1  && old_changed[r + ICoord(-1,0)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,0)];
		else if (pixelInBounds(r + ICoord(-1,1)) && classified[r + ICoord(-1,1)] == 1  && old_changed[r + ICoord(-1,1)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,1)];
		else if (pixelInBounds(r + ICoord(-1,-1)) && classified[r + ICoord(-1,-1)] == 1 && old_changed[r + ICoord(-1,-1)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,-1)];
		classified[r] = 1;
		changed[r] = changeTo;
		if (r(0) < maxi && r(1) < maxj){
			changeNeighbors(r, changed, curr, changeTo, classified, maxi, maxj, old_changed);
		}
	}
	r = coord + ICoord (1,1);
	if ((image.pixelInBounds(&r) == true) && (r(0) < maxi && r(1) < maxj) && (classified[r] == 0) && (old_changed[r] == curr)) {
		if (pixelInBounds(r + ICoord(-1,0)) && classified[r + ICoord(-1,0)] == 1  && old_changed[r + ICoord(-1,0)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,0)];
		else if (pixelInBounds(r + ICoord(-1,1)) && classified[r + ICoord(-1,1)] == 1  && old_changed[r + ICoord(-1,1)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,1)];
		else if (pixelInBounds(r + ICoord(-1,-1)) && classified[r + ICoord(-1,-1)] == 1 && old_changed[r + ICoord(-1,-1)] == old_changed[r])
			changeTo = changed[r + ICoord(-1,-1)];
		classified[r] = 1;
		changed[r] = changeTo;
		if (r(0) < maxi && r(1) < maxj){
			changeNeighbors(r, changed, curr, changeTo, classified, maxi, maxj, old_changed);
		}
	}*/

	
}





