/* -*- C++ -*-
 $RCSfile: diffusionRHS.h,v $
 $Revision: 1.2 $
 $Author: olgak $
 $Date: 2007-07-20 15:37:18 $

 This software was produced by NIST, an agency of the U.S. government,
 and by statute is not subject to copyright in the United States.
 Recipients of this software assume all responsibilities associated
 with its operation, modification and maintenance. However, to
 facilitate maintenance we ask that before distributing modified
 versions of this software, you first contact the authors at
 oof_manager@ctcms.nist.gov. */ 
 
#include <oofconfig.h>
#include "common/doublearray.h"
#include "common/coord.h" 
#include <oofconfig.h>
#include <stdio.h>
#include <math.h>
#include "common/doublearray.h"
#include "image/oofimage.h"
#include <string>
#include <iostream>

#ifndef DIFFUSION_RHS_H
#define DIFFUSION_RHS_H


class DiffusionRHS {
	public:
		DiffusionRHS();
	protected:
		double time;
		DoubleArray gray;
		ICoord size;	
};

class AntiGeometric: public DiffusionRHS {
	public:
		AntiGeometric(double time);
		DoubleArray timestep(DoubleArray gray);
		DoubleArray change(DoubleArray g);

};

class Geometric: public DiffusionRHS {
	public:
		Geometric(double time);
		DoubleArray timestep(DoubleArray gray);
		DoubleArray change(DoubleArray g);
};

class Laplace: public DiffusionRHS {
	public:
		Laplace(double time);
		DoubleArray timestep(DoubleArray gray);
		DoubleArray change(DoubleArray g);
};

class LargeLaplace: public DiffusionRHS {
	public:
		LargeLaplace(double time);
		DoubleArray timestep(DoubleArray gray);
		DoubleArray change(DoubleArray g);
};

class Gaussian: public DiffusionRHS {
	public:
		Gaussian();
		DoubleArray timestep(DoubleArray gray);
		DoubleArray change(DoubleArray g);
};

class LargeGaussian: public DiffusionRHS {
	public:
		LargeGaussian();
		DoubleArray timestep(DoubleArray gray);
		DoubleArray change(DoubleArray g);
};

class NoDiffusion: public DiffusionRHS {
	public:
		NoDiffusion(){ return; };
		DoubleArray timestep(DoubleArray gray){ return gray;};
		DoubleArray change(DoubleArray g){ return g;};
};

#endif
