/* -*- C++ -*-
 $RCSfile: mask.C,v $
 $Revision: 1.4 $
 $Author: olgak $
 $Date: 2007-07-20 15:37:19 $

 This software was produced by NIST, an agency of the U.S. government,
 and by statute is not subject to copyright in the United States.
 Recipients of this software assume all responsibilities associated
 with its operation, modification and maintenance. However, to
 facilitate maintenance we ask that before distributing modified
 versions of this software, you first contact the authors at
 oof_manager@ctcms.nist.gov. */  

 
 #include "mask.h"
 
Mask::Mask(int type) //M and N should be odd
  :maskArray(ICoord(1,1),0.0)
{
	(*this).type = type;
	if (type == GAUSSIAN_MASK){
		maskArray = DoubleArray(ICoord(5,5));
		maskArray[ICoord(2,2)] = 15;
		maskArray[ICoord(0,0)] = 2;
		maskArray[ICoord(0,1)] = 4;
		maskArray[ICoord(0,2)] = 5;
		maskArray[ICoord(0,3)] = 4;
		maskArray[ICoord(0,4)] = 2;
		maskArray[ICoord(1,0)] = 4;
		maskArray[ICoord(1,1)] = 9;
		maskArray[ICoord(1,2)] = 12;
		maskArray[ICoord(1,3)] = 9;
		maskArray[ICoord(1,4)] = 4;
		maskArray[ICoord(2,0)] = 5;
		maskArray[ICoord(2,1)] = 12;
		maskArray[ICoord(2,3)] = 12;
		maskArray[ICoord(2,4)] = 5;
		maskArray[ICoord(3,0)] = 4;
		maskArray[ICoord(3,1)] = 9;
		maskArray[ICoord(3,2)] = 12;
		maskArray[ICoord(3,3)] = 9;
		maskArray[ICoord(3,4)] = 4;
		maskArray[ICoord(4,0)] = 2;
		maskArray[ICoord(4,1)] = 4;
		maskArray[ICoord(4,2)] = 5;
		maskArray[ICoord(4,3)] = 4;
		maskArray[ICoord(4,4)] = 2;
	}
	else if (type == SMALL_GAUSSIAN_MASK){
		maskArray = DoubleArray(ICoord(3,3));
		maskArray[ICoord(0,0)] = 9;
		maskArray[ICoord(0,1)] = 12;
		maskArray[ICoord(0,2)] = 9;
		maskArray[ICoord(1,0)] = 12;
		maskArray[ICoord(1,1)] = 15;
		maskArray[ICoord(1,2)] = 12;
		maskArray[ICoord(2,0)] = 9;
		maskArray[ICoord(2,1)] = 12;
		maskArray[ICoord(2,2)] = 9;
		
	}
	else if (type == LAPLACE_MASK){
		maskArray = DoubleArray(ICoord(5,5));
		maskArray[ICoord(0,0)] = 1;
		maskArray[ICoord(0,1)] = 1;
		maskArray[ICoord(0,2)] = 1;
		maskArray[ICoord(0,3)] = 1;
		maskArray[ICoord(0,4)] = 1;
		maskArray[ICoord(1,0)] = 1;
		maskArray[ICoord(1,1)] = 1;
		maskArray[ICoord(1,2)] = 1;
		maskArray[ICoord(1,3)] = 1;
		maskArray[ICoord(1,4)] = 1;
		maskArray[ICoord(2,0)] = 1;
		maskArray[ICoord(2,1)] = 1;
		maskArray[ICoord(2,3)] = 1;
		maskArray[ICoord(2,4)] = 1;
		maskArray[ICoord(3,0)] = 1;
		maskArray[ICoord(3,1)] = 1;
		maskArray[ICoord(3,2)] = 1;
		maskArray[ICoord(3,3)] = 1;
		maskArray[ICoord(3,4)] = 1;
		maskArray[ICoord(4,0)] = 1;
		maskArray[ICoord(4,1)] = 1;
		maskArray[ICoord(4,2)] = 1;
		maskArray[ICoord(4,3)] = 1;
		maskArray[ICoord(4,4)] = 1;
		maskArray[ICoord(2,2)] = -24;
	}
	else if (type == SMALL_LAPLACE_MASK){
		maskArray = DoubleArray(ICoord(3,3));
		maskArray[ICoord(0,0)] = 1;
		maskArray[ICoord(0,1)] = 1;
		maskArray[ICoord(0,2)] = 1;
		maskArray[ICoord(1,0)] = 1;
		maskArray[ICoord(1,1)] = -8;
		maskArray[ICoord(1,2)] = 1;
		maskArray[ICoord(2,0)] = 1;
		maskArray[ICoord(2,1)] = 1;
		maskArray[ICoord(2,2)] = 1;
	}
	else if (type == X_DERIVATIVE_MASK){
		maskArray = DoubleArray(ICoord(3,3));
		maskArray[ICoord(0,0)] = 0;
		maskArray[ICoord(0,1)] = -.5;
		maskArray[ICoord(0,2)] = 0;
		maskArray[ICoord(1,0)] = 0;
		maskArray[ICoord(1,1)] = 0;
		maskArray[ICoord(1,2)] = 0;
		maskArray[ICoord(2,0)] = 0;
		maskArray[ICoord(2,1)] = .5;
		maskArray[ICoord(2,2)] = 0;
	}
	else if (type == Y_DERIVATIVE_MASK){
		maskArray = DoubleArray(ICoord(3,3));
		maskArray[ICoord(0,0)] = 0;
		maskArray[ICoord(0,1)] = 0;
		maskArray[ICoord(0,2)] = 0;
		maskArray[ICoord(1,0)] = -.5;
		maskArray[ICoord(1,1)] = 0;
		maskArray[ICoord(1,2)] = .5;
		maskArray[ICoord(2,0)] = 0;
		maskArray[ICoord(2,1)] = 0;
		maskArray[ICoord(2,2)] = 0;
	}
	else if (type == YY_DERIVATIVE_MASK){
		maskArray = DoubleArray(ICoord(3,3));
		maskArray[ICoord(0,0)] = 0;
		maskArray[ICoord(0,1)] = 0;
		maskArray[ICoord(0,2)] = 0;
		maskArray[ICoord(1,0)] = 1;
		maskArray[ICoord(1,1)] = -2;
		maskArray[ICoord(1,2)] = 1;
		maskArray[ICoord(2,0)] = 0;
		maskArray[ICoord(2,1)] = 0;
		maskArray[ICoord(2,2)] = 0;
	}
	else if (type == XX_DERIVATIVE_MASK){
		maskArray = DoubleArray(ICoord(3,3));
		maskArray[ICoord(0,0)] = 0;
		maskArray[ICoord(0,1)] = 1;
		maskArray[ICoord(0,2)] = 0;
		maskArray[ICoord(1,0)] = 0;
		maskArray[ICoord(1,1)] = -2;
		maskArray[ICoord(1,2)] = 0;
		maskArray[ICoord(2,0)] = 0;
		maskArray[ICoord(2,1)] = 1;
		maskArray[ICoord(2,2)] = 0;
	}
	else if (type == XY_DERIVATIVE_MASK){
		maskArray = DoubleArray(ICoord(3,3));
		maskArray[ICoord(0,0)] = .25;
		maskArray[ICoord(0,1)] = 0;
		maskArray[ICoord(0,2)] = -.25;
		maskArray[ICoord(1,0)] = 0;
		maskArray[ICoord(1,1)] = 0;
		maskArray[ICoord(1,2)] = 0;
		maskArray[ICoord(2,0)] = -.25;
		maskArray[ICoord(2,1)] = 0;
		maskArray[ICoord(2,2)] = .25;
	}
	else if (type == CANNY_X_MASK){
		maskArray = DoubleArray(ICoord(3,3));
		maskArray[ICoord(0,0)] = -1;
		maskArray[ICoord(0,1)] = -2;
		maskArray[ICoord(0,2)] = -1;
		maskArray[ICoord(1,0)] = 0;
		maskArray[ICoord(1,1)] = 0;
		maskArray[ICoord(1,2)] = 0;
		maskArray[ICoord(2,0)] = 1;
		maskArray[ICoord(2,1)] = 2;
		maskArray[ICoord(2,2)] = 1;
	}
	else if (type == CANNY_Y_MASK){
		maskArray = DoubleArray(ICoord(3,3));
		maskArray[ICoord(0,0)] = 1;
		maskArray[ICoord(0,1)] = 0;
		maskArray[ICoord(0,2)] = -1;
		maskArray[ICoord(1,0)] = 2;
		maskArray[ICoord(1,1)] = 0;
		maskArray[ICoord(1,2)] = -2;
		maskArray[ICoord(2,0)] = 1;
		maskArray[ICoord(2,1)] = 0;
		maskArray[ICoord(2,2)] = -1;
	}
	width = (int)maskArray.size()(0)/2;
}

DoubleArray Mask::applyMask(DoubleArray array){
	ICoord size = array.size();
	// creates a border of size width around the doublearray
	//std::cout << " width is " << width << std::endl;
	DoubleArray newarray = DoubleArray(size);
	for (DoubleArray::iterator i = array.begin();i !=array.end(); ++i){
		ICoord curr = i.coord();
		double num = 0;
		double c = 0;
		for (int i = -width; i <= width; ++i){
			for (int j = -width; j <= width; ++j){
				ICoord a = ICoord(i,j);
				if (pixelInBounds(curr + a, size)){
					num = num + array[curr+a]*maskArray[ICoord(i + width, j + width)];
					//std::cout << a +curr << ": " << num << "  ";
					c = c + maskArray[ICoord(i + width, j + width)];
				}
			}
		}
		//std::cout << std::endl;
		
		if (type == GAUSSIAN_MASK || type == SMALL_GAUSSIAN_MASK)
			newarray[curr] = num/c;
		else if ((type == CANNY_X_MASK || type == CANNY_Y_MASK) && ((curr(0) >= (size(0) -2)) || (curr(1) >= (size(1) -2)) || (curr(0) <= 1) || (curr(1) <= 1))) {
				newarray[curr] = 0;
		}
		else
			newarray[curr] = num;
		//std::cout << curr << " " << size << " " << newarray[curr] << std::endl;
	}
	return newarray;
}

bool Mask::pixelInBounds(ICoord pxl, ICoord size) {
  int xx = (pxl)(0);
  int yy = (pxl)(1);
  if ( (xx<0) || (xx>=size(0)) || (yy<0) || (yy>=size(1)) )
    return false;
  return true;
}

