 /* -*- C++ -*-
 $RCSfile: skeletonize.h,v $
 $Revision: 1.2 $
 $Author: olgak $
 $Date: 2007-07-20 14:17:57 $

 This software was produced by NIST, an agency of the U.S. government,
 and by statute is not subject to copyright in the United States.
 Recipients of this software assume all responsibilities associated
 with its operation, modification and maintenance. However, to
 facilitate maintenance we ask that before distributing modified
 versions of this software, you first contact the authors at
 oof_manager@ctcms.nist.gov. */ 
 
  
#include <oofconfig.h>
#include <stdio.h>
#include <math.h>
#include "common/doublearray.h"
#include "image/oofimage.h"
#include "common/boolarray.h"

#ifndef SKELETONIZING_H
#define SKELETONIZING_H


class Skeletonize{
	private:
		int numNonZeroTransitions(ICoord center, DoubleArray gray);
		int numBorderSides(ICoord center, DoubleArray list, int type);
		bool pixelInBounds(ICoord pxl, ICoord size);
		bool isDeletable(const BoolArray&,ICoord);
		bool satisfiesStep1(const BoolArray&,ICoord);
		bool satisfiesStep2(const BoolArray&,ICoord);
		bool isContour(const BoolArray &image,const ICoord pt);
	public:
		DoubleArray thinEdges(DoubleArray gray);
		DoubleArray skeletonize(DoubleArray&);
		
};



#endif

 
