/* -*- C++ -*-
 $RCSfile: thresholding.h,v $
 $Revision: 1.3 $
 $Author: olgak $
 $Date: 2007-07-20 17:50:58 $

 This software was produced by NIST, an agency of the U.S. government,
 and by statute is not subject to copyright in the United States.
 Recipients of this software assume all responsibilities associated
 with its operation, modification and maintenance. However, to
 facilitate maintenance we ask that before distributing modified
 versions of this software, you first contact the authors at
 oof_manager@ctcms.nist.gov. */
#include <oofconfig.h>
#include "common/doublearray.h"
#include "common/coord.h"
#include <stdio.h>
#include "image/SEGMENTATION/canny.h"
 
#ifndef THRESHOLDING_H
#define THRESHOLDING_H

class Thresholding{

};

class Canny : public Thresholding{
	private:
		double lowerThreshold;
		double upperThreshold;
	public:
		Canny(double lowerThreshold, double upperThreshold);
		DoubleArray threshold(DoubleArray changed, DoubleArray original);
};

class RegularThresholding : public Thresholding {
	private:
		double t;
	public:
		RegularThresholding(double th);
		DoubleArray threshold(DoubleArray changed, DoubleArray original);
		DoubleArray parse(DoubleArray original);
};

class NoThresholding : public Thresholding {
	public:
		NoThresholding(){ return; };
		DoubleArray threshold (DoubleArray changed, DoubleArray original){ return changed;};
};

#endif
